#pragma once

#include <iostream>
#include <math.h>
#include <stdio.h>

#include <fstream>
#include <string>
#include <vector>
#include <sstream>
#include <stdlib.h>

#include <armadillo> //matrices

//boost libraries
#include <boost/random.hpp>
#include "General_Functions.h"

using namespace std;
using namespace arma;

//Para definir os ficheiros de saida, ir ao General_Functions.h e seleccionar os respectivos #defines



//###defining a vector containning the learning coefficients to test the redutor###
vector <float> learnCoeff1;
vector <float> learnCoeff2;
unsigned short numEpochs1;
unsigned short numEpochs2;
	
enum GLOBAL_Train Train_Global = ITL; //can vary between ITL or PROP 
enum TrainMethods_W1 W1_Method; //ENTROPY, CAUCHY_SCHWARTZ, EUCLIDEAN_DISTANCE, UNI (definir o mtodo entre)
enum TrainMethods_W2 W2_Method; //W2_PROP,	CIM,	Corr (definir o mtodo entre)
	
const enum InitializationW1Methods Init_W1_Method = RANDOM_W1; //definir o mtodo de inicializaao de W1 entre: RANDOM_W1, PCA
const enum InitializationW2Methods Init_W2_Method = TRANSPOSE; //definir o mtodo de inicializaao de W2 entre: RANDOM_W2, TRANSPOSE
const enum InitializationB1Methods Init_B1_Method = RANDOM_B1; // RANDOM_B1 or ZEROS_B1
const enum InitializationB2Methods Init_B2_Method = RANDOM_B2; // RANDOM_B2 or ZEROS_B2
const enum ActivationFunctions NeuronActFunct1 = NEURON_ACT_LOGISTIC; //funao de activaao para 1a camada:: NEURON_ACT_LOGISTIC, NEURON_ACT_TANH, NEURON_ACT_LINEAR
const enum ActivationFunctions NeuronActFunct2 = NEURON_ACT_LOGISTIC; //funao de activaao para 2a camada:: NEURON_ACT_LOGISTIC, NEURON_ACT_TANH, NEURON_ACT_LINEAR
const enum NormalizationMethod NormMethod = NONE; // defining normalization method: ENTRANCE_MIN_MAX, GLOBAL_MIN_MAX, ENTRANCE_ZSCORE, GLOBAL_ZSCORE, NONE
const enum sigmaOption sigmaMethod = SILVERMAN_RULE; //	SILVERMAN_RULE or PRINCIPE_RULE
const enum OjaRule OjaDecision = OjaNO; //can change betwee OjaYES and OjaNO

const unsigned short DimIn = 5; // patterns Dimension = first layer Dimension
const unsigned short DimHidden = 100; // output Dimension = hidden layer Dimension
const unsigned short DimOut = 5; // patterns Dimension = output layer Dimension

const float AuxSigma = 1.0f;//percentage of sigma from SilvermanRule

//Seeds Definition Block
unsigned short StartSeedNumber = 2000;
unsigned short NumSeeds = 10;//number of seeds to do: "=1" when using W1 PCA and B1,B2=Zeros
const unsigned short passo = 5;//iteration seed step

//Dimension of train, test and validation sets
const unsigned short TrainDim = 5000; // Numbers of patterns/examples in train set
const unsigned short TestDim = 2000;
const unsigned short ValidationDim = 2000; //number of patterns in the validation set

string TrainSetFile =		"Bessa_TRAIN.csv";	//5000patternsA     MultiAlternadoTrain (escolher o nome do ficheiro)  Tr_aberto  Tr_fechado
string TestSetFile =		"Bessa_TEST.csv";	//2500patternsB     MultiAlternadoTest (escolher o nome do ficheiro) Ts_aberto Ts_fechado
string ValidationSetFile =	"Bessa_VALIDATION.csv";	//2500patternsC     MultiAlternadoValidation (escolher o nome do ficheiro)  
string TargetTrSetFile =	"Bessa_TRAIN.csv";
string TargetTsSetFile =	"Bessa_TEST.csv";
string TargetVlSetFile =	"Bessa_VALIDATION.csv";
string Label_data= ("_Bessa_");
	

const float lr_dec = 0.5f;
const float lr_inc = 1.05f;
const float max_perf_inc = 1.04f; //performance - racio (=CostFunction/Prev_CostFunction) a partir do qual nao se actualizam pesos
const float goal = 0.00000001f; //como no matlab
const float momRate = 0.0f; //momentum coef
const float actFcnFlatness = 1.0f; // For Activation Function

const float SatLimit = 0.9f; //o valor da funo de activao a partir do qual se considera saturado
const float ThresholdSat = 0.3f; //a percentagem mxima permitida de valores saturados a partir da qual se faz uma perturbao aleatria aos pesos
// #### END Main Parameters Definition #####
// #### END Main Parameters Definition #####


void Specifications_function_1AA (GLOBAL_Train &Train_Global,
	unsigned short  &numEpochs1,
	vector <float> &learnCoeff1,
	unsigned short  &numEpochs2,
	TrainMethods_W1 &W1_Method,
	TrainMethods_W2 &W2_Method,
	vector <float> &learnCoeff2
	)
{
	switch (Train_Global)
	{
		case PROP: 
			{
				numEpochs1 = 20;
			
				learnCoeff1.push_back(0.5f);
				learnCoeff1.push_back(0.05f);
				learnCoeff1.push_back(0.005f);
				learnCoeff1.push_back(0.0005f);
				break;
			}
		case ITL: 
			{
				numEpochs1 = 500;
				numEpochs2 = 2000;

				W1_Method = CAUCHY_SCHWARTZ; //ENTROPY, CAUCHY_SCHWARTZ, EUCLIDEAN_DISTANCE, UNI (definir o mtodo entre)
				W2_Method = W2_PROP; // W2_PROP, 	CIM, 	Corr

				//learnCoeff1.push_back(0.005f);
				//learnCoeff1.push_back(0.5f);
				learnCoeff1.push_back(0.05f);
				//learnCoeff1.push_back(0.005f);
				//learnCoeff1.push_back(0.0005f);

				//learnCoeff2.push_back(0.5f);
				//learnCoeff2.push_back(0.05f);
				learnCoeff2.push_back(0.005f);
				learnCoeff2.push_back(0.0005f);
				learnCoeff2.push_back(0.00005f);
				break;
			}
		default: cout << "ERROR!!! ";
	}

}

	//for sigma_corr
	const float AuxSigma2 = 1;//for sigma_corr
	const unsigned short L = 4;//for sigma_corr
	float lrCoeff_sigma = 0.5;//for sigma_corr 
