#pragma once

#include <iostream>
#include <math.h>
#include <stdio.h>

#include <fstream>
#include <string>
#include <vector>
#include <sstream>
#include <stdlib.h>

#include <armadillo> //matrices

//boost libraries
#include <boost/random.hpp>
#include "General_Functions.h"
//#include "MoreFunctions2AAonly.h"

using namespace std;
using namespace arma;




enum FalhasMethods_list 
{
	MSE_FALHAS,
	CIM_FALHAS,
	Corr_FALHAS
};


enum Breaker_list 
{
	B1,
	B2,
	B3,
	B4,
	B5,
	B6,
	B7,
	B8,
	B9,
	B10,
	B11
};

//###defining a vector containning the learning coefficients to test the redutor###
vector <float> learnCoeff1;
vector <float> learnCoeff2;
unsigned short numEpochs1;
unsigned short numEpochs2;

enum Breaker_list ChosenBreaker = B7; //choose between the breakers available
enum GLOBAL_Train Train_Global = ITL; //can vary between ITL or PROP 
enum TrainMethods_W1 W1_Method;
enum TrainMethods_W2 W2_Method;
	
const enum InitializationW1Methods Init_W1_Method = PCA; //definir o mtodo de inicializaao de W1 entre: RANDOM_W1, PCA
const enum InitializationW2Methods Init_W2_Method = TRANSPOSE; //definir o mtodo de inicializaao de W2 entre: RANDOM_W2, TRANSPOSE
const enum InitializationB1Methods Init_B1_Method = ZEROS_B1; // RANDOM_B1 or ZEROS_B1
const enum InitializationB2Methods Init_B2_Method = ZEROS_B2; // RANDOM_B2 or ZEROS_B2
const enum ActivationFunctions NeuronActFunct1 = NEURON_ACT_TANH; //funao de activaao para 1a camada:: NEURON_ACT_LOGISTIC, NEURON_ACT_TANH, NEURON_ACT_LINEAR
const enum ActivationFunctions NeuronActFunct2 = NEURON_ACT_LINEAR; //funao de activaao para 2a camada:: NEURON_ACT_LOGISTIC, NEURON_ACT_TANH, NEURON_ACT_LINEAR
const enum NormalizationMethod NormMethod = GLOBAL_MIN_MAX; // defining normalization method: ENTRANCE_MIN_MAX, GLOBAL_MIN_MAX, ENTRANCE_ZSCORE, GLOBAL_ZSCORE, NONE
const enum sigmaOption sigmaMethod = SILVERMAN_RULE; //	SILVERMAN_RULE or PRINCIPE_RULE
const enum OjaRule OjaDecision = OjaYES; //can change betwee OjaYES and OjaNO
enum FalhasMethods_list FalhasMethod = MSE_FALHAS; //	 MSE_FALHAS, 	CIM_FALHAS,  Corr_FALHAS

//const unsigned short DimIn = 14; // patterns Dimension = first layer Dimension
//const unsigned short DimHidden = 10; // output Dimension = hidden layer Dimension
//const unsigned short DimOut = 14; // patterns Dimension = output layer Dimension

const float AuxSigma = 0.5f;//percentage of sigma from SilvermanRule

//Seeds Definition Block
unsigned short StartSeedNumber = 2000;
unsigned short NumSeeds = 1;//number of seeds to do: "=1" when using W1 PCA and B1,B2=Zeros
const unsigned short passo = 5;//iteration seed step

unsigned short TotalValidationDim = 10000;

//string breaker
string TrainSetFile_A (""); 
string TestSetFile_A ("");	//
string ValidationSetFile_A (""); //  
string TargetTrSetFile_A ("");
string TargetTsSetFile_A ("");
string TargetVlSetFile_A ("");
string Label_data_A ("");

string TrainSetFile_F ("");	//
string TestSetFile_F ("");	//
string ValidationSetFile_F (""); //  
string TargetTrSetFile_F ("");
string TargetTsSetFile_F ("");
string TargetVlSetFile_F ("");
string Label_data_F ("");

string ValidationSet_B ("");
string ValidationKey_B ("");

unsigned short TestDim_A, ValidationDim_A, TrainDim_A, TestDim_F, ValidationDim_F, TrainDim_F, DimIn, DimHidden, DimOut;

const float lr_dec = 0.5f;
const float lr_inc = 1.05f;
const float max_perf_inc = 1.04f; //performance - racio (=CostFunction/Prev_CostFunction) a partir do qual nao se actualizam pesos
const float goal = 0.00000001f; //como no matlab
const float momRate = 0.0f; //momentum coef
const float actFcnFlatness = 1.0f; // For Activation Function

const float SatLimit = 0.9f; //o valor da funo de activao a partir do qual se considera saturado
const float ThresholdSat = 0.3f; //a percentagem mxima permitida de valores saturados a partir da qual se faz uma perturbao aleatria aos pesos
// #### END Main Parameters Definition #####
// #### END Main Parameters Definition #####


void Specifications_function_2AA (
	vector <float> &learnCoeff1, 
	vector <float> &learnCoeff2,
	unsigned short &numEpochs1, 
	unsigned short &numEpochs2,
	TrainMethods_W1 &W1_Method,
	TrainMethods_W2 &W2_Method,  
	const GLOBAL_Train &Train_Global,
	const Breaker_list &ChosenBreaker,
	unsigned short &TestDim_A, 
	unsigned short &ValidationDim_A,
	unsigned short &TrainDim_A, 
	unsigned short &TestDim_F,
	unsigned short &ValidationDim_F, 
	unsigned short &TrainDim_F, 
	unsigned short &DimIn, 
	unsigned short &DimHidden,
	unsigned short &DimOut,
	string &TrainSetFile_A, 
	string &TestSetFile_A, 
	string &ValidationSetFile_A, 
	string &TargetTrSetFile_A,
	string &TargetTsSetFile_A, 
	string &TargetVlSetFile_A, 
	string &Label_data_A, 
	string &TrainSetFile_F,
	string &TestSetFile_F, 
	string &ValidationSetFile_F, 
	string &TargetTrSetFile_F, 
	string &TargetTsSetFile_F,
	string &TargetVlSetFile_F, 
	string &Label_data_F, 
	string &ValidationSet_B,
	string &ValidationKey_B
	)
{
	switch (Train_Global)
	{
		case PROP: 
		{
			numEpochs1 = 2000;
			
			learnCoeff1.push_back(0.5f);
			learnCoeff1.push_back(0.05f);
			learnCoeff1.push_back(0.005f);
			learnCoeff1.push_back(0.0005f);
			break;
		}
		case ITL: 
		{
			numEpochs1 = 2000;
			numEpochs2 = 2000;

			W1_Method = CAUCHY_SCHWARTZ; //ENTROPY, CAUCHY_SCHWARTZ, EUCLIDEAN_DISTANCE, UNI (definir o mtodo entre)
			W2_Method = W2_PROP; // W2_PROP, 	CIM, 	Corr

			//learnCoeff1.push_back(50.0f);
			//learnCoeff1.push_back(5.0f);
			//learnCoeff1.push_back(0.5f);
			//learnCoeff1.push_back(0.005f);
			learnCoeff1.push_back(0.005f);
			//learnCoeff1.push_back(0.00005f);
			//learnCoeff1.push_back(0.000005f);

			//learnCoeff2.push_back(0.5f);
			learnCoeff2.push_back(0.5f);
			learnCoeff2.push_back(0.005f);
			learnCoeff2.push_back(0.0005f);
			learnCoeff2.push_back(0.00005f);
			break;
		}
		default: cout << "ERROR!!! ";
	}


	switch (ChosenBreaker)
	{
		case B1: 
		{
			TestDim_A=1006, ValidationDim_A= 4956,TestDim_F=994,ValidationDim_F= 5044, DimIn=14, DimHidden=10, DimOut=14; //B1
			TrainDim_A=4058, TrainDim_F= 3942;
			
			TrainSetFile_A= "treinoAberto_B1.csv"; 
			TestSetFile_A =	"testeAberto_B1.csv";	//
			ValidationSetFile_A = "validationAberto_B1.csv"; //  
			TargetTrSetFile_A =	"treinoAberto_B1.csv";
			TargetTsSetFile_A =	"testeAberto_B1.csv";
			TargetVlSetFile_A =	"validationAberto_B1.csv";
			Label_data_A= "_Aberto_B1_";

			TrainSetFile_F = "treinoFechado_B1.csv";	//
			TestSetFile_F =	"testeFechado_B1.csv";	//
			ValidationSetFile_F = "validationFechado_B1.csv"; //  
			TargetTrSetFile_F =	"treinoFechado_B1.csv";
			TargetTsSetFile_F =	"testeFechado_B1.csv";
			TargetVlSetFile_F =	"validationFechado_B1.csv";
			Label_data_F= "_Fechado_B1_";

			ValidationSet_B = "validationSet_B1.csv";
			ValidationKey_B = "validationKey_B1.csv";
			break;
		}
		case B2: 
		{
			TestDim_A=980, ValidationDim_A= 4987,TestDim_F=1020,ValidationDim_F= 5013, DimIn=18, DimHidden=14, DimOut=18; //B2
			TrainDim_A=4060, TrainDim_F= 3940;

			TrainSetFile_A= "treinoAberto_B2.csv"; 
			TestSetFile_A =	"testeAberto_B2.csv";	//
			ValidationSetFile_A = "validationAberto_B2.csv"; //  
			TargetTrSetFile_A =	"treinoAberto_B2.csv";
			TargetTsSetFile_A =	"testeAberto_B2.csv";
			TargetVlSetFile_A =	"validationAberto_B2.csv";
			Label_data_A= "_Aberto_B2_";

			TrainSetFile_F = "treinoFechado_B2.csv";	//
			TestSetFile_F =	"testeFechado_B2.csv";	//
			ValidationSetFile_F = "validationFechado_B2.csv"; //  
			TargetTrSetFile_F =	"treinoFechado_B2.csv";
			TargetTsSetFile_F =	"testeFechado_B2.csv";
			TargetVlSetFile_F =	"validationFechado_B2.csv";
			Label_data_F= "_Fechado_B2_";
			ValidationSet_B = "validationSet_B2.csv";
			ValidationKey_B = "validationKey_B2.csv";
			break;
		}
		case B3: 
		{
			TestDim_A=998, ValidationDim_A= 4992,TestDim_F=1002,ValidationDim_F= 5008, DimIn=16, DimHidden=12, DimOut=16; //B3
			TrainDim_A=4009, TrainDim_F= 3991;

			TrainSetFile_A= "treinoAberto_B3.csv"; 
			TestSetFile_A =	"testeAberto_B3.csv";	//
			ValidationSetFile_A = "validationAberto_B3.csv"; //  
			TargetTrSetFile_A =	"treinoAberto_B3.csv";
			TargetTsSetFile_A =	"testeAberto_B3.csv";
			TargetVlSetFile_A =	"validationAberto_B3.csv";
			Label_data_A= "_Aberto_B3_";

			TrainSetFile_F = "treinoFechado_B3.csv";	//
			TestSetFile_F =	"testeFechado_B3.csv";	//
			ValidationSetFile_F = "validationFechado_B3.csv"; //  
			TargetTrSetFile_F =	"treinoFechado_B3.csv";
			TargetTsSetFile_F =	"testeFechado_B3.csv";
			TargetVlSetFile_F =	"validationFechado_B3.csv";
			Label_data_F= "_Fechado_B3_";
			ValidationSet_B = "validationSet_B3.csv";
			ValidationKey_B = "validationKey_B3.csv";
			break;
		}
		case B4: 
		{
			TestDim_A=978, ValidationDim_A= 5056,TestDim_F=1022,ValidationDim_F= 4944, DimIn=16, DimHidden=12, DimOut=16; //B4
			TrainDim_A=4076, TrainDim_F= 3924;

			TrainSetFile_A= "treinoAberto_B4.csv"; 
			TestSetFile_A =	"testeAberto_B4.csv";	//
			ValidationSetFile_A = "validationAberto_B4.csv"; //  
			TargetTrSetFile_A =	"treinoAberto_B4.csv";
			TargetTsSetFile_A =	"testeAberto_B4.csv";
			TargetVlSetFile_A =	"validationAberto_B4.csv";
			Label_data_A= "_Aberto_B4_";

			TrainSetFile_F = "treinoFechado_B4.csv";	//
			TestSetFile_F =	"testeFechado_B4.csv";	//
			ValidationSetFile_F = "validationFechado_B4.csv"; //  
			TargetTrSetFile_F =	"treinoFechado_B4.csv";
			TargetTsSetFile_F =	"testeFechado_B4.csv";
			TargetVlSetFile_F =	"validationFechado_B4.csv";
			Label_data_F= "_Fechado_B4_";
			ValidationSet_B = "validationSet_B4.csv";
			ValidationKey_B = "validationKey_B4.csv";
			break;
		}
		case B5: 
		{
			TestDim_A=1003, ValidationDim_A= 4961,TestDim_F=997,ValidationDim_F= 5039, DimIn=16, DimHidden=12, DimOut=16; //B5
			TrainDim_A=3965, TrainDim_F= 4035;

			TrainSetFile_A= "treinoAberto_B5.csv"; 
			TestSetFile_A =	"testeAberto_B5.csv";	//
			ValidationSetFile_A = "validationAberto_B5.csv"; //  
			TargetTrSetFile_A =	"treinoAberto_B5.csv";
			TargetTsSetFile_A =	"testeAberto_B5.csv";
			TargetVlSetFile_A =	"validationAberto_B5.csv";
			Label_data_A= "_Aberto_B5_";

			TrainSetFile_F = "treinoFechado_B5.csv";	//
			TestSetFile_F =	"testeFechado_B5.csv";	//
			ValidationSetFile_F = "validationFechado_B5.csv"; //  
			TargetTrSetFile_F =	"treinoFechado_B5.csv";
			TargetTsSetFile_F =	"testeFechado_B5.csv";
			TargetVlSetFile_F =	"validationFechado_B5.csv";
			Label_data_F= "_Fechado_B5_";
			ValidationSet_B = "validationSet_B5.csv";
			ValidationKey_B = "validationKey_B5.csv";
			break;
		}
		case B6: 
		{
			TestDim_A=983, ValidationDim_A= 4948,TestDim_F=1017,ValidationDim_F= 5052, DimIn=14, DimHidden=10, DimOut=14; //B6
			TrainDim_A=3887, TrainDim_F= 4113;

			TrainSetFile_A= "treinoAberto_B6.csv"; 
			TestSetFile_A =	"testeAberto_B6.csv";	//
			ValidationSetFile_A = "validationAberto_B6.csv"; //  
			TargetTrSetFile_A =	"treinoAberto_B6.csv";
			TargetTsSetFile_A =	"testeAberto_B6.csv";
			TargetVlSetFile_A =	"validationAberto_B6.csv";
			Label_data_A= "_Aberto_B6_";

			TrainSetFile_F = "treinoFechado_B6.csv";	//
			TestSetFile_F =	"testeFechado_B6.csv";	//
			ValidationSetFile_F = "validationFechado_B6.csv"; //  
			TargetTrSetFile_F =	"treinoFechado_B6.csv";
			TargetTsSetFile_F =	"testeFechado_B6.csv";
			TargetVlSetFile_F =	"validationFechado_B6.csv";
			Label_data_F= "_Fechado_B6_";
			ValidationSet_B = "validationSet_B6.csv";
			ValidationKey_B = "validationKey_B6.csv";
			break;
		}
		case B7: 
		{
			TestDim_A=991, ValidationDim_A= 5016,TestDim_F=1009,ValidationDim_F= 4984, DimIn=16, DimHidden=12, DimOut=16; //B7
			TrainDim_A=3992, TrainDim_F= 4008;

			TrainSetFile_A= "treinoAberto_B7.csv"; 
			TestSetFile_A =	"testeAberto_B7.csv";	//
			ValidationSetFile_A = "validationAberto_B7.csv"; //  
			TargetTrSetFile_A =	"treinoAberto_B7.csv";
			TargetTsSetFile_A =	"testeAberto_B7.csv";
			TargetVlSetFile_A =	"validationAberto_B7.csv";
			Label_data_A= "_Aberto_B7_";

			TrainSetFile_F = "treinoFechado_B7.csv";	//
			TestSetFile_F =	"testeFechado_B7.csv";	//
			ValidationSetFile_F = "validationFechado_B7.csv"; //  
			TargetTrSetFile_F =	"treinoFechado_B7.csv";
			TargetTsSetFile_F =	"testeFechado_B7.csv";
			TargetVlSetFile_F =	"validationFechado_B7.csv";
			Label_data_F= "_Fechado_B7_";
			ValidationSet_B = "validationSet_B7.csv";
			ValidationKey_B = "validationKey_B7.csv";
			break;
		}
		case B8: 
		{
			TestDim_A=1001, ValidationDim_A=5010, TestDim_F=999,ValidationDim_F= 4990, DimIn=12, DimHidden=8, DimOut=12; //B8
			TrainDim_A=4093, TrainDim_F= 3907;

			TrainSetFile_A= "treinoAberto_B8.csv"; 
			TestSetFile_A =	"testeAberto_B8.csv";	//
			ValidationSetFile_A = "validationAberto_B8.csv"; //  
			TargetTrSetFile_A =	"treinoAberto_B8.csv";
			TargetTsSetFile_A =	"testeAberto_B8.csv";
			TargetVlSetFile_A =	"validationAberto_B8.csv";
			Label_data_A= "_Aberto_B8_";

			TrainSetFile_F = "treinoFechado_B8.csv";	//
			TestSetFile_F =	"testeFechado_B8.csv";	//
			ValidationSetFile_F = "validationFechado_B8.csv"; //  
			TargetTrSetFile_F =	"treinoFechado_B8.csv";
			TargetTsSetFile_F =	"testeFechado_B8.csv";
			TargetVlSetFile_F =	"validationFechado_B8.csv";
			Label_data_F= "_Fechado_B8_";
			ValidationSet_B = "validationSet_B8.csv";
			ValidationKey_B = "validationKey_B8.csv";
			break;
		}
		case B9: 
		{
			TestDim_A=953, ValidationDim_A= 5061,TestDim_F=1047,ValidationDim_F= 4939, DimIn=12, DimHidden=8, DimOut=12; //B9
			TrainDim_A=3998, TrainDim_F= 4002;

			TrainSetFile_A= "treinoAberto_B9.csv"; 
			TestSetFile_A =	"testeAberto_B9.csv";	//
			ValidationSetFile_A = "validationAberto_B9.csv"; //  
			TargetTrSetFile_A =	"treinoAberto_B9.csv";
			TargetTsSetFile_A =	"testeAberto_B9.csv";
			TargetVlSetFile_A =	"validationAberto_B9.csv";
			Label_data_A= "_Aberto_B9_";

			TrainSetFile_F = "treinoFechado_B9.csv";	//
			TestSetFile_F =	"testeFechado_B9.csv";	//
			ValidationSetFile_F = "validationFechado_B9.csv"; //  
			TargetTrSetFile_F =	"treinoFechado_B9.csv";
			TargetTsSetFile_F =	"testeFechado_B9.csv";
			TargetVlSetFile_F =	"validationFechado_B9.csv";
			Label_data_F= "_Fechado_B9_";
			ValidationSet_B = "validationSet_B9.csv";
			ValidationKey_B = "validationKey_B9.csv";
			break;
		}
		case B10: 
		{
			TestDim_A=987, ValidationDim_A= 4943,TestDim_F=1013,ValidationDim_F= 5057, DimIn=16, DimHidden=12, DimOut=16; //B10
			TrainDim_A=4004, TrainDim_F= 3996;

			TrainSetFile_A= "treinoAberto_B10.csv"; 
			TestSetFile_A =	"testeAberto_B10.csv";	//
			ValidationSetFile_A = "validationAberto_B10.csv"; //  
			TargetTrSetFile_A =	"treinoAberto_B10.csv";
			TargetTsSetFile_A =	"testeAberto_B10.csv";
			TargetVlSetFile_A =	"validationAberto_B10.csv";
			Label_data_A= "_Aberto_B10_";

			TrainSetFile_F = "treinoFechado_B10.csv";	//
			TestSetFile_F =	"testeFechado_B10.csv";	//
			ValidationSetFile_F = "validationFechado_B10.csv"; //  
			TargetTrSetFile_F =	"treinoFechado_B10.csv";
			TargetTsSetFile_F =	"testeFechado_B10.csv";
			TargetVlSetFile_F =	"validationFechado_B10.csv";
			Label_data_F= "_Fechado_B10_";

			ValidationSet_B = "validationSet_B10.csv";
			ValidationKey_B = "validationKey_B10.csv";
			break;
		}

		case B11: 
		{
			TestDim_A=956, ValidationDim_A= 5067,TestDim_F=1044,ValidationDim_F= 4933, DimIn=18, DimHidden=13, DimOut=18; //B11
			TrainDim_A=4000, TrainDim_F= 4000;
			
			TrainSetFile_A= "treinoAberto_B11.csv"; 
			TestSetFile_A =	"testeAberto_B11.csv";	//
			ValidationSetFile_A = "validationAberto_B11.csv"; //  
			TargetTrSetFile_A =	"treinoAberto_B11.csv";
			TargetTsSetFile_A =	"testeAberto_B11.csv";
			TargetVlSetFile_A =	"validationAberto_B11.csv";
			Label_data_A= "_Aberto_B11_";

			TrainSetFile_F = "treinoFechado_B11.csv";	//
			TestSetFile_F =	"testeFechado_B11.csv";	//
			ValidationSetFile_F = "validationFechado_B11.csv"; //  
			TargetTrSetFile_F =	"treinoFechado_B11.csv";
			TargetTsSetFile_F =	"testeFechado_B11.csv";
			TargetVlSetFile_F =	"validationFechado_B11.csv";
			Label_data_F= "_Fechado_B11_";

			ValidationSet_B = "validationSet_B11.csv";
			ValidationKey_B = "validationKey_B11.csv";
			break;
		}


		default: cout << "ERROR!!! ";
	}

}

	//for sigma_corr
	const float AuxSigma2 = 1;//for sigma_corr
	const unsigned short L = 4;//for sigma_corr
	float lrCoeff_sigma = 0.5;//for sigma_corr 
